IT门户网,专注电脑知识与技术及手机硬件信息服务网站!

当前位置:IT门户网 > 网络知识 > 网站seo >

P-HP异常处理惩罚浅析

时间:2021-09-14    来源:IT门户网    人气:

  PHP预定了两个异常类:Exception和ErrorException

   代码如下:

  Exception {

  /* 属性 */

  protected string $message ; //异常动静内容

  protected int $code ; //异常代码号

  protected string $file ; //抛出异常的文件名

  protected int $line ; //抛出异常在该文件中的行号

  /* 要领 */

  public __construct ([ string $message = "" [, int $code = 0 [, Exception $previous = null]]] )

  final public string getMessage ( void ) //异常抛出的信息

  final public Exception getPrevious ( void ) //前一异常

  final public int getCode ( void ) //异常代码,这是用户自界说的

  final public string getFile ( void ) //产生异常的文件路劲

  final public int getLine ( void ) //产生异常的行

  final public array getTrace ( void ) //异常追踪信息(array)

  final public string getTraceAsString ( void ) //异常追踪信息(string)

  public string __toString ( void ) //试图直接 将异常工具看成字符串利用时挪用子函数的返回值

  final private void __clone ( void ) //克隆异常工具时挪用

  }

   代码如下:

  ErrorException extends Exception {

  /* 属性 */

  protected int $severity ;

  /* 要领 */

  public __construct ([ string $message = "" [, int $code = 0 [, int $severity = 1 [, string $filename = __FILE__ [, int $lineno = __LINE__ [, Exception $previous = NULL ]]]]]] )

  final public int getSeverity ( void )

  /* 担任的要领 */

  final public string Exception::getMessage ( void )

  final public Exception Exception::getPrevious ( void )

  final public int Exception::getCode ( void )

  final public string Exception::getFile ( void )

  final public int Exception::getLine ( void )

  final public array Exception::getTrace ( void )

  final public string Exception::getTraceAsString ( void )

  public string Exception::__toString ( void )

  final private void Exception::__clone ( void )

  }

  那么如何捕捉异常?

  (1)PHP可用try...catch...捕捉异常,举办异常处理惩罚的代码必需在try代码块内。

   代码如下:

  try {

  throw new Exception('exception test 1', 1001);

  } catch(Exception $e) {

  echo $e->getMessage().'-'.$e->getCode();

  }

  (2)用户可以自界说异常处理惩罚函数[set_exception_handler],用于没用用try/catch捕捉的异常。

   代码如下:

  function exception_handler ( $e ) {

  echo "Uncaught exception: " , $e -> getMessage (), "n" ;

  }

  set_exception_handler ( 'exception_handler' );

  throw new Exception ( 'Uncaught Exception' );

  echo "这行不会执行了";

  可以看到利用ser_exception_handler回调函数处理惩罚异常,后续的代码不会继承执行,但try-catch可以。

  (3)PHP可用多catch捕捉差异范例异常,并答允在catch代码块内再次抛出异常。

相关文章

网站seo排行榜

更多>>

网络知识排行榜

更多>>

系统教程排行榜

更多>>

服务号